{{

  Progue - a rogue-like written in Spin
  Copyright (C) 2007  Christopher Merck
  Contact: navaburo@gmail.com

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
   
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  Progue uses VGA and keyboard drives authored by Parallax, Inc.
   See object files for appropriate credit.

  Thanks to Mike Green for his terminal emulation code in the video driver.  

  If you have any questions / comments / bug reports / bug fixes,
   or changes to the code please email them to me (navaburo@gmail.com),
   or post to the Parallax forum thread on the game:
   <http://forums.parallax.com/forums/default.aspx?f=33&m=195502>

  Enjoy,
   Chris
   
  }}

CON
   {{This program will work on the Parallax demo board or Hydra kit,
      simply set the appropriate constant}}
   Demo      = true                   ' Demo Board
   Proto     = false                  ' Proto Board
   Hydra     = false                  ' Hydra

   version   = 0
   release   = 2
   
   'progsize  = 8192                    ' Space reserved for program
   _clkmode  = xtal1 + ((Hydra & pll8x) | ((Demo | Proto) & pll16x))
   _xinfreq  = (Hydra & 10_000_000) | ((Demo | Proto) & 5_000_000)
   _stack    = 100                     ' Roughly 4 nested expressions
   '_free     = (progsize + dsp#rows * (dsp#cols + 2) + 12) / 4

'  dspPins   = (Hydra & 24) | ((Demo | Proto) & 12)   ' TV
   dspPins   = 16                                     ' VGA
   keyPins   = (Hydra & 13) | ((Demo | Proto) & 26)


  'terminal signals
  ClrScr = $00
  Home   = $01
  Seek   = $02 
  Bsp    = $08
  Cr     = $0D
  MoveX  = $0E
  MoveY  = $0F

  cols = 80
  rows = 40
   
OBJ

  text : "vga_Drive"          
  kb   : "comboKeyboard"

CON

  titleblock_x = cols / 2 - 25
  titleblock_y = rows / 2 - 5

  map_w = 60
  map_h = 30

  map_x_offset = 10
  map_y_offset = 4  

  {{player modifiers (states)}}
  hungry = 0
  burdened = 1
  poisoned = 2
  bleeding = 3
  confused = 4
  paralyzed = 5
  blessed = 6
  cursed = 7

  {{item states}}
  broken = 0
  heavy = 1
  strong = 2
  weak = 3
  ancient = 4
  rare = 5
  'blessed = 6
  'cursed = 7

  {{monster modifiers}}
  m_claws = 31
  m_weapon = 30 'deals more damage and may drop a weapon
  m_armor = 29 'has higher PV
  m_fast = 28 'harder to hit, and moves faster than PC
  m_angry = 27 'easier to hit, deals more damage, chance to drop blood
  m_eatable = 26 'chance to drop corpse
  m_poison = 25 'can use poison attack, corpse is poisonous
  m_fire = 24 'can use fire attack, resistant to fire, weak to ice
  m_ice = 23 'can use ice attack, resistant to ice, weak to fire
  m_undead = 22 'change to curse PC, weak to blessed weapons
  m_sentry = 21 'cannot move
  m_archer = 20 'can use missile attack, chance to drop bow/arrows
  m_breeder = 19 'occasionaly reproduces asexually (beware!)
  m_flying = 18 'harder to hit, moves sparatically, changes message
  m_weak = 17 'very few hit points (useful for regulating difficulty)
  m_confusing = 16
  m_common = 15
  m_rare = 14   'both common AND rare make for VERY rare 
  m_stone_thrower = 13 'throws rocks, may drop rocks, may drop pick axe
  m_friendly = 12 'doesnt attack unless attacked
  m_speak = 11
  m_strong = 10 'more hit points, deals (a little) more damage
  m_swap = 9 'monster can swap positions with you during combat (cannot make another move that turn)
  m_dodge = 8 'monster can sometimes dodge attacks by moving to an adjacent tile (cannot make another move that turn)
  
  'TODO add more modifiers
  'modifiers 0-7 are reserved for storing monster level
  ' this is both the first dungeon level they may be found on,
  ' and forms the basis for their hit points and damage. 
  
  'runtime monster attributes
  max_monsters = 32
  mr_active = 0  'this rid is in use
  mr_tame = 1    'does not attack PC
  mr_afraid = 2  'runs away
  mr_tapped = 3  'cannot move this turn (after swap, dodge, or being stunned)

  max_pack_items = 16
  equip_slots = 8
  {slot definitions}
  e_armor = 0   '+PV 
  e_weapon = 1  '+hit & +damage 
  e_shield = 2  '+DV
  e_boots = 3   '+speed & protection from traps
  e_amulet = 4  'magical effects
  e_bow = 5     'ranged weapon
  e_arrows = 6  'ammunition
  e_ring = 7    'magical effects

  'weapon and armor modifier flags
  wa_broken = 7   'cannot be used (unless reforged)
  wa_rusty = 6    'higher chance to break
  wa_poisoned = 5 'poisons enemy
  wa_reserved = 4
  
VAR

  {{map data storage format:
        byte #1: display symbol (type)
        byte #2: detail byte

        TILE CLASS / FLAG: 0      1      2      3      4      5      6      7
        monster:        reserved.............................................
        potion, weapon, armor: holds index number for lookup table
        gold:           holds amount
        arrows, rocks:  holds quantity         
  }}
  word map [map_w*map_h]
  word tmp_swap

  {{monster ai memory - holds information about each active monster on the map 
        byte #1: X position
        byte #2: Y position 'TODO more can be squeezed from here as X,Y only needs 11-bits, not 16
        byte #3: flags: 0=in_use see mr_xxx
        byte #4: hp
  }}
  long monster[max_monsters]
  word under_monster[max_monsters] 'holds tile at the feet of the monster

  {{your pack contains collected items such as potions, scrolls, weapons, armor,
    ammunition, food, and artifacts.
     you can carry up to 16 items in the pack
     the format for items in the pack is identical to that of map tiles
  }}
  word pack[max_pack_items]

  {{when you equip an item from the pack it leaves the pack and enters an equipment slot}}
  word equip[equip_slots]
                
  byte level 'floor of the dungeon PC is on

  byte key 'key pressed this move

  {{player properties}}
  byte p_x, op_x
  byte p_y, op_y
  long p_hp, p_hp_max
  long p_mp, p_mp_max
  long p_xp, p_level
  byte p_state
  byte p_vision
  long p_bgl 'blood glucose level (1000+ is satiated, 500- is hungry, 0 is dead)
  long p_luck      '0 is really bad luck... you DONOT want 0 luck.... really
  

  byte tmp1, tmp2

  long dice

  long dir_x
  long dir_y

  byte free_dir 'flags possible free directions
  {
        0  1  2
        3     4               
        5  6  7               
  }

  long turn_count

PUB start | i, mn, rid, damage, tmp

  'initialize devices
  text.start(16)
  kb.start(keyPins)

  'display title block
  text.locate(titleblock_x,titleblock_y)
  repeat 50
    text.out("*")
  text.locate(titleblock_x,titleblock_y+1)
  text.str(string("* Progue - a rogue-like RPG written in pure Spin *"))
  text.locate(titleblock_x,titleblock_y+2)
  text.str(string("*     Copyright (C) 2007  Christopher Merck      *"))
  text.locate(titleblock_x,titleblock_y+3)
  text.str(string("*           Contact: navaburo@gmail.com          *"))
  text.locate(titleblock_x,titleblock_y+4)
  repeat 50
    text.out("*")
  text.locate(titleblock_x+9,titleblock_y+6)
  text.str(string("developer preview version 0."))
  text.dec(version)
  text.out(".")
  text.dec(release)
  text.out(Home)                               'ensure a keyboard is present
  waitcnt(clkfreq + cnt) 'wait one second
  if not kb.present  
    text.str(string("searching for keyboard"))                
    repeat
      waitcnt(clkfreq / 1000 * 500 + cnt)
      text.out(".")
    until kb.present
    text.str(string("found!"))     
  text.locate(titleblock_x+10,rows-1)
  text.str(string("-  PRESS ANY KEY TO CONTINUE  -"))
  kb.getkey

  text.out(ClrScr)
  text.swap_cursor 'for use by message buffer 
  text.out(Home)
  
  {*** GAME AND PC INITIALIZATION ***}
  level := 0

  p_hp_max := p_hp := 10
  p_mp_max := p_mp := 10
  p_xp := 0
  p_vision := 4
  p_luck := 128 'start with fair luck


  turn_count := 0
  repeat
    {INITIALIZE MAP}
    

    text.out(ClrScr)
    p_x := 4
    p_y := 4

    text.locate(titleblock_x,titleblock_y)
    repeat 50
      text.out("*")
    text.locate(titleblock_x,titleblock_y+1)
    text.str(string("*               LEVEL  "))
    text.dec(level)
    text.str(string("                         *"))
    text.locate(titleblock_x,titleblock_y+2)
    repeat 50
      text.out("*")

    randomize_map  

      
    i := 0      'initialize monster storage area
    repeat max_monsters
      monster[i] := $00000000
      under_monster[i++] := $0000

    repeat
    until kb.peekkey

    text.out(ClrScr)
    
    repeat
      key := kb.getkey 'wait for keystroke
      
      turn_count++
      text.out(Home)  'clear and reset message buffer
      text.swap_cursor
      text.out(Home)
      repeat cols*(map_y_offset-1)
        text.out(" ")
      op_x := p_x 'save PC position
      op_y := p_y

      
      {*** PARSE USER COMMAND ***}
      case key      
        'non-movement commands:
        $3F,$68: '? or h
          'TODO: display in-game help
          'this would be a big waste of memory, so just display keybindings
          message(string("Progue keybindings: h=help  e=eat  q=quaff  t=throw/shoot  r=wear ring  d=drop   arrowkeys/numpad=walk  5=rest v=version"))
          next
        $65: 'e
          'TODO eat
          'seach pack for food items, how many?
          'if none, say "you own no food"
          'if one, display "you eat the ____" and increase energy level
          'if multiple, allow user to select which to eat

          'for now we just eat a corpse from the ground:
          if map[p_x+p_y*map_w] & $00FF == "%" 
            message(string("You eat the "))
            say_tile(p_x,p_y)
            map[p_x+p_y*map_w] := "." 'delete corpse
            p_hp := p_hp_max
            message(string(". Mmmmmm tasty! ")) 
          else
            message(string("Try standing over something eatable! "))
          
          message(string("You eat Sam. "))
          p_bgl += roll(3,100) 'TODO add nurishment messages...
          'if poisoned food, make player poisoned
        $6B: 'l
          message(string("To the right of you is: "))
          say_tile(p_x+1,p_y)
        $71: 'q
          'TODO quaff
          'seach pack for potions, how many?
          'if none, say "you own no potions"
          'if one, apply its effect
          'if multiple, allow user to select which to quaff
        $74: 't
          'TODO fire zee meezilez (throw)
        $72: 'r
          'TODO wear ring
          'search pack for a rings, how many?
          'if none, say "you own no rings"
          'if one, move it to equip[e_ring]
          'if multiple, allow user to select which to equip
        '$?: 'd
          'TODO drop
          'move item from pack to ground beneith feet
        $2E,$3E: '>   go downstairs
          if map[p_x+p_y*map_w] == ">"
            quit 'exit level loop, decending deeper!

        'movement commands  
        $E1,$31:
          p_x -= 1
          p_y += 1
        $E2,$32,$C3:
          p_y += 1
        $E3,$33:
          p_x += 1
          p_y += 1
        $E4,$34,$C0:
          p_x -= 1
        $E5,$35:
          message(string("You rest. "))
        $E6,$36,$C1:
          p_x += 1
        $E7,$37:
          p_x -= 1
          p_y -= 1
        $E8,$38,$C2:
          p_y -= 1
        $E9,$39:                                             
          p_x += 1
          p_y -= 1

      if (op_x <> p_x OR op_y <> p_y) 'check for attempted movement      
        'on-step events (cancelling move if nessisary):
        if p_state & |<paralyzed
          message(string("You can't move! "))
          p_x := op_x 'cancel move
          p_y := op_y
        
        case map[p_x+p_y*map_w] 
          "#": 'wall (non traversable, inanimate tile)
            message(string("Ouch! You bump into the hard stone wall. "))
            p_x := op_x 'cancel move
            p_y := op_y
            if roll(1,3) == 1
              p_luck := (p_luck - 1) #> 0
          "+": 'closed door
            message(string("You open the door. ")) 'TODO: add stuck and trapped doors
            map[p_x+p_y*map_w] := "\"
            p_x := op_x 'cancel move
            p_y := op_y                      
          " ": 'trap
            message(string("You fall into the open pit! "))
            p_hp := (p_hp - 5) #> 0'hurt the PC
          "_": 'altar
            message(string("You step onto the altar. "))            
          "0": 'pool
            message(string("You step into the pool. "))
          ">","<":
            message(string("A stairwell leads "))
            if map[p_x+p_y*map_w] == "<"
              message(string("up"))
            else
              message(string("down"))
            message(string("wards here. "))
          ".": 'boring floor tile, do nothing!
                        
          'TODO: more item walk-onto events


          


          {*** PC ATTACKING MONSTER ***}
          "a".."z","A".."Z": 'monster
            mn := map[p_x+p_y*map_w] - "a" 'gets the species of the monster
            rid := get_monster_rid(p_x,p_y)'identifies instance of monster being attacked                        
            'check weapon
               'no weapon
               'message(string("Try equiping a weapon first! "))
            'todo, add monster swapping and dodging (better at this if m_fast?)               
            message(string("You "))
            damage := roll(2,6+p_level)
            if monster.BYTE[4*rid+2] & |<mr_tame     'check if this is a backstab (backstabs allways hit!)
              monster.BYTE[4*rid+2] &= !(|<mr_tame)
              p_luck := (p_luck - 5) #> 0 'it's bad luck to backstab!
              message(string("backstab "))              
            elseif (roll(1,10) =< 7)   'TODO: roll for hit (based on weapon and monster)
              if damage == 0 'TODO: roll for damage TODO: subtract monster PV
                 message(string("fail to damage "))
              else
                 message(string("hit "))
            else
              message(string("miss "))
              damage := 0
            monster.BYTE[4*rid+3] := (monster.BYTE[4*rid+3] - damage) #> 0 'apply damage to monster
            message(string("the "))
            say_monster_name(mn)
            text.swap_cursor
            'text.out("(")
            'text.dec(rid)
            'text.out(")")
            text.swap_cursor            
            if monster.BYTE[4*rid+3] == 0 'if monster's health was reduced to zero gain experience
              message(string(", slaying it. "))
              tmp := get_monster_level(mn)
              p_xp += tmp + roll(3,tmp) + 1
              if (2*tmp > (p_level + level))
                p_xp += roll(8,tmp) 'give bonus for slaying out of depth monster
                message(string("You feel more experienced. "))
            elseif not (monster_table[3*mn + 2] & |<m_angry) AND roll(1,12) == 1 'roll for monster becoming afraid (if not m_angry)
                monster.BYTE[4*rid+2] |= |<mr_afraid
                message(string(", frighting it. "))
            else        'no post-attack effect
                message(string(". "))            
            p_x := op_x 'cancel move
            p_y := op_y

            

          other:
            message(string("A "))
            say_tile(p_x,p_y)
            message(string(" lies here. "))


            



          
      {*** MONSTER AI ***}
      rid := -1
      repeat 'for each active monster
        tmp := monster[++rid]
        if tmp.BYTE[2] == 0 'no ai for disabled monsters
          next
        mn := rid2monster_number(rid)
        
        if tmp.BYTE[3] == 0 'check for dying monsters (no hp left)
          {message(string("The "))
          say_monster_name(mn)
          message(string(" collapses. "))}
          {TODO: the following is a bit of a hack. The monster will not drop a corpse if there is an item on the tile
           it was standing on when it died. This is because there cannot be multiple items on a single tile. The monster
           standing on an item is already a sloppy swap-buffer (under_monster[] array). If I ever add item stacking this
           can be fixed. }
          if monster_table[3*mn+2] & |<m_eatable AND under_monster[rid] == "." 'roll for droping corpse if eatable
            map[tmp.BYTE[0]+tmp.BYTE[1]*map_w] := "%" | (mn*256) 'leave corpse on floor, properly identified
          else
            map[tmp.BYTE[0]+tmp.BYTE[1]*map_w] := under_monster[rid] 'no corpse, just restore old tile
          tmp.BYTE[2] := 0 'unset active flag (removes monster from memory)

        elseif not (tmp.BYTE[2] & |<mr_tapped)  'try to move
          dir_x := dir_y := 0
          get_free_dir(tmp.BYTE[0],tmp.BYTE[1]) 'enumerate directions which can be moved in
          
          if tmp.BYTE[2] & |<mr_tame 'if tame, walk aimlessly            
            i := roll(1,8)-2            'choose a random free direction
            if free_dir & |<i
              set_dir(i)                    ' sets dir_x/y globals
            if tmp.BYTE[0]+dir_x+(tmp.BYTE[1]+dir_y)*map_w == p_x+p_y*map_w 'dont hit PC
              dir_x := dir_y := 0
            
          elseif tmp.BYTE[2] & |<mr_afraid  'else-if afraid, move away from pc (or cower if blocked in)
            i := roll(1,8)-2
            repeat 9              'find a direction away from the PC       
              i := ++i // 8       '"
              set_dir(i)
              if free_dir & |<i AND (||(tmp.BYTE[0]+dir_x - p_x) + ||(tmp.BYTE[1]+dir_y - p_y)) > (||(tmp.BYTE[0] - p_x) + ||(tmp.BYTE[1] - p_y)) 
                quit                   
            if not (free_dir & |<i) OR i == 8             
              dir_x := dir_y := 10  'flag for prefering a neutral move       
            
          else 'else move towards pc (in any direction which would decrease distance-to-pc)
            i := roll(1,8)-2
            repeat 9              'find a direction towards the PC       
              i := ++i // 8       '"
              set_dir(i)
              if free_dir & |<i AND (||(tmp.BYTE[0]+dir_x - p_x) + ||(tmp.BYTE[1]+dir_y - p_y)) < (||(tmp.BYTE[0] - p_x) + ||(tmp.BYTE[1] - p_y)) 
                quit                   
            if not (free_dir & |<i) OR i == 8             
              dir_x := dir_y := 10
                   
          if dir_x == 10 'check for attempt neutral move flag
            dir_x := dir_y := 0
            i := roll(1,8)-2
            repeat 8              'find a direction towards the PC       
              i := ++i // 8       '"
              set_dir(i)
              if free_dir & |<i AND (||(tmp.BYTE[0]+dir_x - p_x) + ||(tmp.BYTE[1]+dir_y - p_y)) == (||(tmp.BYTE[0] - p_x) + ||(tmp.BYTE[1] - p_y)) 
                quit                   
            if not (free_dir & |<i)             
              dir_x := dir_y := 0

          if tmp.BYTE[0] + dir_x == p_x AND tmp.BYTE[1] + dir_y == p_y  'if move would place monster on top of pc, the monster is attacking
            dir_x := dir_y := 0  'don't let monster move on top of PC            
            message(string("The "))
            say_monster_name(mn)
            if roll(1,7) => 3 'roll for hit (based on monster level and modifiers)              
              damage := (roll(1,get_monster_level(mn)+1) - p_level/3) #> 0 'TODO: PC protected by armor (PV)  (for now player level is the PV)
              if damage == 0
                message(string(" fails to hurt you. ")) 
              else
                message(string(" hits you. "))
                p_hp -= damage
                if roll(1,50) == 1 OR (roll(1,20) AND monster_table[3*mn+2] & |<m_angry) 'roll for drawing blood (much increased by m_angry)
                  p_state |= |<bleeding
            else
              message(string(" misses you. "))              
          
          'move monster data and restore old tile
          if dir_x <> 0 OR dir_y <> 0  'if it moved at all                                              'trinodal tile shuffle
            tmp_swap := map[tmp.BYTE[0]+dir_x+(tmp.BYTE[1]+dir_y)*map_w]                                't = n                  
            map[tmp.BYTE[0]+dir_x+(tmp.BYTE[1]+dir_y)*map_w] := map[tmp.BYTE[0]+tmp.BYTE[1]*map_w]      'n = m                  'm -> n
            map[tmp.BYTE[0]+tmp.BYTE[1]*map_w] := tmp_swap                                              'm = t
            tmp_swap := under_monster[rid]                                                              't = u
            under_monster[rid] := map[tmp.BYTE[0]+tmp.BYTE[1]*map_w]                                    'u = m                  'n -> u
            map[tmp.BYTE[0]+tmp.BYTE[1]*map_w] := tmp_swap                                              'm = t                  'u -> m
            'if tmp_swap.BYTE[0] <> "."
              'message(string("The "))
              'say_monster_name(mn)
              'message(string(" displaces the "))
              'say_tile(tmp.BYTE[0],tmp.BYTE[1])    'item only (can't displace other monsters)
              'message(string(". "))            
            tmp.BYTE[0] += dir_x 'move monster
            tmp.BYTE[1] += dir_y
                
        monster[rid] := tmp
      until rid == max_monsters - 1






       {*** APPLY EFFECTS ***}
      'take care of static effects due to items underfoot
      case map[p_x+p_y*map_w]
        "_":
          if (p_mp < p_mp_max)
            p_mp++
            message(string("You feel pious! "))
        "0":
          if (p_hp < p_hp_max)
            p_hp++
            message(string("You feel refreshed! "))
            
      if p_state & |<poisoned
        tmp := roll(2,6) - 5      'roll for poison damage (or cure)
        if tmp == -3              
          p_state &= !(|<poisoned)'cure poison
        if tmp > 0
          message(string("The poison runs through your veins. "))
          p_hp := (p_hp - tmp) #> 0

      if p_state & |<paralyzed
        if roll(1,8) == 1
          p_state &= !(|<paralyzed)
          message(string("You can move again! "))          


      {LEVEL UP!}
      if p_xp/60 > p_level 'TODO make this logarithmic
        p_level++
        p_hp_max += p_level*2
        p_hp += p_level*2
        if p_level//3 == 0
          p_vision++
        message(string("Your muscles feel stronger. "))

          
      {*** REDRAW SCREEN (as needed) ***}
      'text.out(ClrScr)
      redraw_visable

      'draw charicter
      text.locate(p_x+map_x_offset,p_y+map_y_offset)
      text.out("@")

      'update stats indicator
      text.locate(1,rows - 4)
      text.str(string("HP "))
      text.dec(p_hp)
      text.str(string("("))
      text.dec(p_hp_max)
      text.str(string(")  MP "))
      text.dec(p_mp)
      text.str(string("("))
      text.dec(p_mp_max)
      text.str(string(")  XP "))
      text.dec(p_level)
      text.out("/")
      text.dec(p_xp)
      text.str(string("  VISION "))
      text.dec(p_vision)
      text.out(MoveX)
      text.out(cols - 17)
      text.str(string("DUNGEON LEVEL "))
      text.dec(level)
      text.str(string("  "))
      'output state of various player modifiers   
      text.locate(1,rows - 2) 
      repeat cols - 2 'clear line
        text.out(" ")
      text.out(MoveX)
        text.out(1)
      if p_luck == 0
        text.str(string("Doomed "))      
      elseif p_luck < 90
        text.str(string("Unlucky "))
      elseif p_luck > 160
        text.str(string("Lucky "))
      'TODO the rest of them
      
      

      {*** LOOSING THE GAME ***}
      if p_luck == 0 AND roll(1,256*8) == 1 'chance of insta-death when doomed                          
        message(string("A previously unseen loose block in the ceiling dislodges and falls square on your head. "))
        p_hp := 0 'kill the PC
      if p_hp =< 0
        message(string("You die... "))
        repeat 'GAME OVER
        
    level++
                                

PUB roll(number_of_dice, number_of_sides) : retval
  retval := 0
  repeat number_of_dice
    retval += ||(dice?//number_of_sides) + 1

PUB say_monster_name(monster_number) | b1, b2, i
  b1 := monster_table[3*monster_number    ]    'get the two longs holding the monster name
  b2 := monster_table[3*monster_number + 1]
  text.swap_cursor 
  i:=0
  repeat 4
    if b1.BYTE[i] == " "
      text.swap_cursor
      quit
    text.out(b1.BYTE[i++])
  i:=0
  repeat 4
    if b2.BYTE[i] == " "
      text.swap_cursor
      quit
    text.out(b2.BYTE[i++])
  text.swap_cursor

PUB get_monster_level(monster_number) : m_level
  m_level := monster_table[3*monster_number + 2] & $F 'extract low nibble from "monster details" long

PUB get_monster_rid(x_pos,y_pos) : rid | tmp
  rid := 0
  repeat 32
    tmp := monster[rid]   
    if tmp.BYTE[0] == x_pos AND tmp.BYTE[1] == y_pos AND tmp.BYTE[2] <> 0
      return rid
    rid++
  return -1

PUB rid2monster_number(rid) : mn
  mn := monster[rid]                 'grab x,y
  mn := map[mn.BYTE[0] + map_w * mn.BYTE[1]] 'grab map tile
  mn := mn.BYTE[0] - $61 'convert to monster number from tile (todo: check for uppercase monsters)

PUB first_free_rid  : rid  | tmp
  rid := 0
  repeat 32
    if (monster[rid] & $00FF0000) == 0
      return rid
    rid++
  message(string("FATAL ERROR: too many active monsters. "))    
  return -1

PUB get_free_dir(x_pos,y_pos) | i, j
  free_dir := 0
  i := 0
  repeat
   case i
    0:
      j := (x_pos - 1) + (y_pos - 1)*map_w
    1:
      j := (x_pos + 0) + (y_pos - 1)*map_w
    2:
      j := (x_pos + 1) + (y_pos - 1)*map_w
    3:
      j := (x_pos - 1) + (y_pos + 0)*map_w
    4:
      j := (x_pos + 1) + (y_pos + 0)*map_w
    5:
      j := (x_pos - 1) + (y_pos + 1)*map_w
    6:
      j := (x_pos + 0) + (y_pos + 1)*map_w
    7:
      j := (x_pos + 1) + (y_pos + 1)*map_w
   
   case map[j]
     "#","a".."z","A","Z":
       free_dir |= |<i
       
  until ++i == 8
   
  !free_dir

PUB set_dir(i)
  dir_x := dir_y := 0
  case i
    0:
      dir_x--
      dir_y--
    1:
      dir_y--
    2:
      dir_x++
      dir_y--
    3:
      dir_x--
    4:
      dir_x++
    5:
      dir_x--
      dir_y++
    6:
      dir_y++
    7,8:
      dir_x++
      dir_y++

PUB say_dir(i) | ptr 'delme
  case i
    0:
      message(string("up-left")) 
    1:
      message(string("up"))   
    2:
      message(string("up-right"))   
    3:
      message(string("left"))   
    4:
      message(string("right"))   
    5:
      message(string("down-left"))   
    6:
      message(string("down"))   
    7:
      message(string("down-right"))   

PUB say_tile(x_pos,y_pos) | tile
  tile := map[x_pos + y_pos*map_w]
  case tile.BYTE[0]
    "a".."z","A".."Z": 'monster
      say_monster_name(tile.BYTE[0] - $61)
      text.swap_cursor
      text.str(string(" (level "))
      text.dec(get_monster_level(tile.BYTE[0] - $61))
      text.str(string(", hp "))
      text.dec(monster.BYTE[4*get_monster_rid(x_pos,y_pos)+3])
      text.str(string(")"))
      tile := monster[get_monster_rid(x_pos,y_pos)]
      if tile.BYTE[2] & |<mr_tame
        text.str(string(" {tame}"))
      if tile.BYTE[2] & |<mr_afraid
        text.str(string(" {afraid}"))
      text.swap_cursor            
    "!":
      message(string("potion"))   'todo: add suffixes for various modifiers
    "0":
      message(string("pool"))     ' ditto et al
    "?":
      message(string("scroll"))
    "_":
      message(string("altar"))
    "$":
      message(string("gold"))
    "%":
      say_monster_name(tile.BYTE[1])
      message(string(" corpse"))
    other:
      message(string("unidentified object"))

PUB message(stringptr) 'display a message in the message buffer
  text.swap_cursor
  text.str(stringptr)
  text.swap_cursor   

PUB darken_line(line) | i
  {{When the torch-light leaves a tile we darken it,
     unless it is a wall tile, in which case it stays
     to show the outline of the level visited so far.}}
  i := -1
  text.locate(map_x_offset+p_x - p_vision - 1,map_y_offset+p_y - p_vision + line) 'erase old top line
  repeat 
    if map[p_x - p_vision + i + map_w*(p_y - p_vision + line)] == "#"
      text.out(Seek)
    else
      text.out(" ")
  until ++i == p_vision * 2 + 3

PUB redraw_visable | i, tmp, rid, xp, yp, tmp_, ml, mn
      'draw visable area
      tmp1 := 0
      darken_line(-1)           
      repeat
        darken_line(tmp1)                                                               
        text.locate(map_x_offset+p_x - p_vision,map_y_offset+p_y - p_vision + tmp1)
        tmp2 := 0           
        xp := p_x - p_vision + tmp2
        yp := p_y - p_vision + tmp1
        repeat
          xp := p_x - p_vision + tmp2
          yp := p_y - p_vision + tmp1
          i := (yp)*map_w + xp
          'todo: determine if an object blocks the path of light
          'if (||(tmp1 - p_vision) + ||(tmp2 - p_vision)) =< p_vision AND yp < map_h AND yp => 0 AND xp < map_w AND xp => 0
          if yp < map_h AND yp => 0 AND xp < map_w AND xp => 0 'an octadirectional system has square circles
            tmp := map[i]
            text.out(map[i])
            case tmp.BYTE                      'monsters activate when you see them... (todo make them activate at a more appropriate time?)
              "a".."z","A".."Z":                  
                rid := get_monster_rid(xp,yp)
                if rid == -1 'check for a new monster
                  rid := first_free_rid
                  mn := tmp.BYTE - $61
                  ml := get_monster_level(mn)
                  under_monster[rid] := "." 'monsters spawn above normal tiles
                  tmp_.BYTE[0] := xp & $FF
                  tmp_.BYTE[1] := yp & $FF
                  tmp_.BYTE[2] := 1  'set active flag (todo: do other stuff)
                  tmp_.BYTE[3] := roll(ml+1,2) + ml 'TODO: is this balenced?
                  if monster_table[3*mn + 2] & |<m_friendly OR roll(1,6) == 1 'some creatures spawn tame
                    tmp_.BYTE[2] |= |<mr_tame 
                  monster[rid] := tmp_  
                  message(string("You see a "))     
                  say_monster_name(mn)
                  say_tile(xp,yp)
                  message(string(". "))                                        
          else
            text.out(Seek)  'placeholder (don't display anything)     
        until tmp2++ == p_vision*2 + 1 
      until tmp1++ == p_vision*2 + 1
      darken_line(tmp1)

      'all you touch and all you see are all your life will ever be
  
PUB redraw_map | i

  'text.out(0) 'clear screen (doesnt work????)
  text.out(Home)
  i := 0
  repeat map_h
    text.locate(map_x_offset,map_y_offset+i/map_w)
    repeat map_w
      text.out(map[i++])

PUB randomize_map | r, x, y, tmp, tmp_
{{GENERATE A RANDOM DUNGEON LEVEL:
 the key concept of Progue levels is that initially they consist of nothing but ASCII
 that is, there is no binary component to them. As the level is played through binary
 components are created and stored in the second byte of each tile word, and elsewhere.
}}

  'todo: make player's name help seed dungeon (clever)

  r := level

  y := 0
  repeat
      x := 0
      repeat
        case ?r//1000
          00..04:
            tmp := "$" 'coins  
          10..13:
            tmp := "!" 'potion
          20..22:
            tmp := "0" 'pool   
          46..47:
            tmp := "?" 'scroll 
          48:
            tmp := "=" 'ring
          49:
            tmp := "_" 'altar
          50..60:
            tmp := " " 'open pit
          100..400:
            tmp := "#" 'wall
          500..510: 'monster!
            repeat
              tmp := roll(1,26)-1    'choose a random monster
              tmp_ := monster_table[3*tmp + 2]
            until (tmp_ & $FF) =< level 'only spawn appropriate monsters
            tmp += $61 'convert to lowercase letters 
            
          other:
            tmp := "." 'floor                
        map[x+y*map_w] := tmp
      until ++x == map_w
  until ++y == map_h
  map[4*4*map_w] := $2E 'ensure the players starting position is clear

  'map[roll(4,map_w-4)+roll(4,map_h-4)*map_w] := ">" 'spawn down staircase

  map[50+25*map_w] := ">"
  
  'add boarder
  x := -1
  repeat map_w
    map[ ++x ] := map[ x + (map_h-1)*map_w] := "#"
  y := -1
  repeat map_h
    map[++y *map_w] := map[(map_w-1) + y *map_w] := "#"     
    

PUB charmap | asc
  text.out(Home)                                        
  text.str(string("CHARMAP ",7))
    
  asc := 1
  repeat
    text.locate(0+8*(asc/rows),asc//rows)    
    text.hex(asc,2)

    text.locate(4+8*(asc/rows),asc//rows)    
    text.out(asc)
  until asc++ == 255

  'kb.newkey 'wait for keystroke


DAT

{{Item Tables}}
'potion item details contains the potion id number
potion_table byte
'     name               id   effect
byte "mana",0           '0 +mp
byte "healing",0        '1 +hp
byte "invisibility",0   '2 non-undead monsters cannot follow you
byte "beer",0           '3 +hp
byte "poison",0         '4 set poisoned
byte "wisdom",0         '5 +xp
byte "troll blood",0    '6 set angry
byte "water",0          '7
byte "Pmana",0          '8 +mp_max
byte "Pstrength",0      '9 +hp_max
byte "farsight",0       '10 +vision (temporary?)
byte "charcoal",0       '11 -bgl (causes vomiting)

{weapon_table byte
'weapon details contain 4bit weapon id and four bit modifier flags
'the higher the weapon id, the more "high-level" it is.
'0-3  deal ~2 dmg
'4-7  deal ~4 dmg
'8-11 deal ~10 dmg
'12-15 are epic weapons ~15 dmg plus some special effect
'note: +hit normal is 5. 10 is perfect. over 10 means a shield cannot be warn (then subtract 10 to get actual +hit rating) 
     'name                XdY damage  
byte "dagger",0,          5,     1,4 'basic weapon level 
byte "whip",0,            4,     2,2
byte "brass knuckles",0,  19,    1,1
byte "light hammer",0,    3,     2,4

byte "short sword",0,     5,     1,8 'intermediate level        
byte "battle axe",0,      3,     2,5
byte "quarterstaff",0,    17,    1,10

byte "troll club",0,      2,     5,8 'advanced level
byte "long sword",0,      5,     2,10         
byte "warhammer",0,       3,     4,8
byte "great flail",0,     8,     8,2

byte "Sword of a Thousand Truths",0, 5, 2,10 'any damage done heals PC that amount   'todo rewatch south park season 10 episde 1
byte "Staff of the Magi",0,17,   1,15        '3*mp_max
byte "Reaper's Sythe",0,  15,    5,8         'causes instadeath to all non-undead, unnamed monsters hit
byte "Hammer of God",0,   14,    8,8         'instadeath to all undead hit

armor_table byte
'armor details contain 4bit armor id and four bit modifier flags.
' The first item in each group (bits 0 and 1 are zero) is a shield.

'higher armour id the more "high-level" it is.
'0-3  provide little effect
'4-7  provide ~4 total effect
'8-11 provide ~8 total effect 
'12-15 are epic armor and have some special effect
'note: 5 DV means +0, higher is + lower is -. PV is as written.
     'name              'DV     '+PV    '+to_hit (less than 5 means misses more often)
byte "wooden",0,        7,      0,      5
byte "robe",0,          6,      0,      5
byte "light furs",0,    4,      2,      5
byte "leather armor",0, 5,      1,      5

byte "medium",0,        9,      0,      4  
byte "dark cloak",0,    7,      1,      5
byte "thick furs",0,    4,      5,      4
byte "light mail",0,    5,      3,      5 

byte "giant",0,         13,     0,      4
byte "elven cloak",0,   9,      2,      5
byte "cave bear skin",0,4,      8,      4   
byte "chain mail",0,    6,      7,      5

byte "Electromagnetic",0, 20,   0,      3 'very good sheild! (75% chance to block magic attacks)
byte "Daemon's Garb",0,   7,    2,      5 'wearer is invisible to non-undead creatures
byte "Fish Scales",0,     5,     5,      5 'wearer can breath under water
byte "Mithril Chain Mail",0,    8,     9,      5 'unbreakable, does not rust
                 }

{{Spell Table}}
'TODO spell_table byte

{{Message Table}}
'TODO: place repeated messages here to save on memory

{{Monster Table}}
''format is three longs per letter of the alphabet: monster name (8 bytes), property long
monster_table long
byte "ant     ", long 0 | |<m_claws | |<m_fast
byte "bat     ", long 0 | |<m_flying | |<m_common
byte "centiped", long 4 | |<m_claws
byte "wolf    ", long 6 | |<m_eatable | |<m_common | |<m_angry | |<m_claws | |<m_dodge
byte "dark-eye", long 7 | |<m_confusing | |<m_weak | |<m_rare
byte "cat     ", long 1 | |<m_eatable | |<m_weak | |<m_dodge
byte "goblin  ", long 4 | |<m_stone_thrower | |<m_armor | |<m_speak | |<m_dodge
byte "halfling", long 13 | |<weak | |<m_armor | |<m_weapon | |<m_eatable | |<m_speak
byte "imp     ", long 10 | |<m_fire | |<m_undead | |<m_flying
byte "joker   ", long 12 | |<m_weak | |<m_friendly | |<m_rare | |<m_speak | |<m_swap
byte "kobold  ", long 8 | |<m_archer 'special: make poisonous meat
byte "lizard  ", long 2 | |<m_common
byte "mime    ", long 11 | |<m_rare | |<m_swap
byte "ice-newt", long 4 | |<m_rare | |<m_ice
byte "orc     ", long 4 | |<m_common | |<m_armor | |<m_weapon | |<m_eatable | |<m_dodge
byte "pixie   ", long 3 | |<rare | |<m_common | |<m_swap'special: drops ALOT of money -- VERY RARE
byte "mage    ", long 9 | |<m_speak | |<m_fire | |<m_ice | |<m_weak
byte "rat     ", long 0 | |<m_common
byte "serpent ", long 9 | |<m_poison
byte "troll   ", long 14 | |<m_weapon | |<m_angry | |<m_eatable | |<m_strong | |<m_speak
byte "dark-elf", long 12 | |<m_rare | |<m_ice | |<m_archer | |<m_speak | |<m_weak | |<m_fast | |<m_dodge
byte "raptor  ", long 15 | |<m_common | |<m_fast | |<m_eatable | |<m_claws | |<m_angry | |<m_dodge
byte "worm    ", long 4 | |<m_breeder
byte "skeleton", long 9 | |<m_common | |<m_undead
byte "gollum  ", long 14 | |<m_confusing | |<m_stone_thrower | |<m_strong | |<m_undead | |<m_rare 
byte "zombie  ", long 13 | |<m_undead | |<m_weak | |<m_common
'TODO: uppercase letters? named monsters?





{{NOTES}}

{{on storing map files for special levels (non-random) or for saving a game:

a special level would consume 60*30 bytes of space (modifiers not needed) = 1.8k

saving an arbitrary level would consume 60*30*2 = 3.6k

however, if saving a particular dungeon level just the delta from the initial version
 could be recorded, thus greatly reducing the space required to at most 256 bytes.
  ( 64 dynamic tiles with X, Y, SYMBOL, and MODIFIERS fields)




{{try using line drawing algorithm for vision!

    public void lineBresenham(int x0, int y0, int x1, int y1, Color color)
    {
        int pix = color.getRGB();
        int dy = y1 - y0;
        int dx = x1 - x0;
        int stepx, stepy;

        if (dy < 0) { dy = -dy;  stepy = -1; } else { stepy = 1; }
        if (dx < 0) { dx = -dx;  stepx = -1; } else { stepx = 1; }
        dy <<= 1;                                                  // dy is now 2*dy
        dx <<= 1;                                                  // dx is now 2*dx

        raster.setPixel(pix, x0, y0);
        if (dx > dy) {
            int fraction = dy - (dx >> 1);                         // same as 2*dy - dx
            while (x0 != x1) {
                if (fraction >= 0) {
                    y0 += stepy;
                    fraction -= dx;                                // same as fraction -= 2*dx
                }
                x0 += stepx;
                fraction += dy;                                    // same as fraction -= 2*dy
                raster.setPixel(pix, x0, y0);
            }
        } else {
            int fraction = dx - (dy >> 1);
            while (y0 != y1) {
                if (fraction >= 0) {
                    x0 += stepx;
                    fraction -= dy;
                }
                y0 += stepy;
                fraction += dx;
                raster.setPixel(pix, x0, y0);
            }
        }
    }
}















MAP GENERATION:


* worm autonima???? american scientist?

* stack based follow path <kevin>

* 

}}